import java.awt.Color;
import java.lang.*;
import java.util.Arrays;
import java.util.Random;

//--------------------------------------------------------------------//
/**
 * DLA tN^f
 */
public class DLAModel{

/** ʕ */
  protected int width;

/** ʍ */
  protected int height;

/** q̐ */
  protected int particleCount;

/** ̗q̐ */
  protected int movingCount;

/** ʃsNZi[z */
  protected int pixel[];

/** qi[z */
  protected Particle p[];

/** wiF RGB l */
  protected int bgColor;

/** ÏW̕\F RGB l */
  protected int onColor;

/** Vq\F RGB l */
  protected int pColor;

/** WFl[^[ */
  protected Random random;

/**
 * DLA tN^f\z
 * @param width ʕ
 * @param height ʍ
 */
  public DLAModel(int width,int height){
    this(width,height,-1);
  }

/**
 * DLA tN^f\z
 * @param width ʕ
 * @param height ʍ
 * @param seed [̎
 */
  public DLAModel(int width,int height,int seed){
    this.width=width;
    this.height=height;
    init();
    if(seed>0) random.setSeed(seed);
  }

//--------------------------------------------------------------------//
/**
 * f[^
 */
  private void init(){
    bgColor=Color.BLACK.getRGB();
    onColor=Color.WHITE.getRGB();
    pColor=new Color(0,0,153).getRGB();

    particleCount=2*(width+height)-4;
    p=new Particle[particleCount];
    movingCount=particleCount;
    for(int i=0;i<width-1;i++){
      p[i]=new Particle(i,0);
      p[i+width-1]=new Particle(i,height-1);
    }
    int phalf=2*width-2;
    for(int i=0;i<height-1;i++){
      p[i+phalf]=new Particle(0,i);
      p[i+phalf+height-1]=new Particle(width-1,i);
    }

    pixel=new int[width*height];
    Arrays.fill(pixel,bgColor);
// 
    pixel[width*height/2+width/2]=onColor;

    random=new Random();
  }

//--------------------------------------------------------------------//
/**
 * ʃsNZԂ
 * @return  ʃsNZi[z
 */
  public int[] getPixel(){
    return pixel;
  }

//--------------------------------------------------------------------//
/**
 * vZǂ𔻕ʂ
 * @return  vZꍇ true
 */
  public boolean isFinished(){
    return (movingCount==0);
  }

//--------------------------------------------------------------------//
/**
 * ̃XebvvZ
 */
  public void next(){
    for(int i=0;i<pixel.length;i++){
      if(pixel[i]==pColor) pixel[i]=bgColor;
    }
    for(int i=0;i<particleCount;i++){
      if(!p[i].isAddCore()){
// _EH[N
      	randomWalk(p[i]);

// ÏW̔
      	int point=point(p[i]);
      	if(checkAdd(point,p[i])){
      	  pixel[point]=onColor;
      	  p[i].addCore();
      	  movingCount--;
      	}
      	else{
      	  pixel[point]=pColor;
      	}
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * _EH[ŇvZ
 * @param p _EH[N闱q
 */
  protected void randomWalk(Particle p){
    double value=random.nextDouble();

// ֈړ
    if(value<0.25){
// ǂɂԂꍇ͔˂
      if(p.x==0){
      	p.move(Particle.RIGHT);
      }
      else{
      	p.move(Particle.LEFT);
      }
    }
// Eֈړ
    else if(value<0.5){
      if(p.x==width-1){
      	p.move(Particle.LEFT);
      }
      else{
      	p.move(Particle.RIGHT);
      }
    }
// ֈړ
    else if(value<0.75){
      if(p.y==0){
      	p.move(Particle.DOWN);
      }
      else{
      	p.move(Particle.UP);
      }
    }
// ֈړ
    else{
      if(p.y==height-1){
      	p.move(Particle.UP);
      }
      else{
      	p.move(Particle.DOWN);
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * qÏW邩ǂ肷
 * @param point qʒu|C^
 * @param p Ώۂ̗q
 * @return qÏWꍇ true
 */
  protected boolean checkAdd(int point,Particle p){
    if(pixel[point]==onColor) return false;
    if(p.x==0){
      if(pixel[point+1]==onColor) return true;
    }
    else if(p.x==width-1){
      if(pixel[point-1]==onColor) return true;
    }
    else{
      if((pixel[point-1]==onColor) || (pixel[point+1]==onColor))
      	return true;
    }
    if(p.y==0){
      if(pixel[point+width]==onColor) return true;
    }
    else if(p.y==height-1){
      if(pixel[point-width]==onColor) return true;
    }
    else{
      if((pixel[point-width]==onColor) || (pixel[point+width]==onColor))
      	return true;
    }
    return false;
  }

//--------------------------------------------------------------------//
/**
 * qʒu|C^Ԃ
 * @param p q
 * @return qʒu|C^
 */
  protected int point(Particle p){
    return width*p.y+p.x;
  }
}
